/*	$NecBSD: lpthwtab.h,v 1.1.18.2 2000/08/30 17:41:42 honda Exp $	*/
/*	$NetBSD$	*/

/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 1994, 1995, 1996, 1997, 1998
 *	NetBSD/pc98 porting staff. All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * LPT HW DEFINITIONS
 * By N. Honda
 */

struct lpt_softc;
int not_ready_error_old __P((struct lpt_softc *));
int not_ready_error_ps2 __P((struct lpt_softc *));

static bus_addr_t lpt_hw_iat_TRADNEC[] = {
	0x00,	/* data */
	0x02,	/* status */
	0x06,	/* control */
	0x10c,	/* PnP config A */
	0x10d,	/* PnP config B */
	0x109,	/* mode */
	0x10e,	/* ext mode */
	0x100,	/* alt data */
	0x101,	/* alt status */
	0x102,	/* alt control */
};

static struct lpt_hw lpt_hw_TRADNEC = {
	LPT_HW_TRADNEC,	/* subtype */
	LPT_MODE_OLD,
	LPT_CAPABILITY_MODEFIXED,

	0x40,	/* fixed iobase */
	8,	/* fixed irq */

	8,	/* ports */

	lpt_hw_iat_TRADNEC,
	BUS_SPACE_IAT_SZ(lpt_hw_iat_TRADNEC),

	not_ready_error_old,	/* the same as above */
};

static bus_addr_t lpt_hw_iat_nec[] = {
	0x100,	/* data */
	0x101,	/* status */
	0x102,	/* control */
	0x10c,	/* PnP config A */
	0x10d,	/* PnP config B */
	0x109,	/* mode */
	0x10e,	/* ext mode */
	0x00,	/* alt data */
	0x02,	/* alt status */
	0x06	/* alt control */
};

static struct lpt_hw lpt_hw_NEC = {
	LPT_HW_NEC,	/* subtype */
	LPT_MODE_FIFO,
	LPT_CAPABILITY_EXTREGS,

	0x40,	/* fixed iobase */
	14,	/* fixed irq */

	0x10,	/* ports */

	lpt_hw_iat_nec,
	BUS_SPACE_IAT_SZ(lpt_hw_iat_nec),

	not_ready_error_ps2,
};

static bus_addr_t lpt_hw_iat_generic[] = {
	0x00,	/* data */
	0x01,	/* status */
	0x02,	/* control */
	0x00,	/* PnP config A */
	0x00,	/* PnP config B */
	0x00,	/* mode */
	0x00,	/* ext mode */
	0x00,	/* alt data */
	0x01,	/* alt status */
	0x02	/* alt control */
};
static struct lpt_hw lpt_hw_IBM = {
	LPT_HW_PS2,	/* subtype */
	LPT_MODE_STANDARD,
	0,

	0,	/* fixed iobase */
	0,	/* fixed irq */

	0x10,	/* ports */

	lpt_hw_iat_generic,
	BUS_SPACE_IAT_SZ(lpt_hw_iat_generic),

	not_ready_error_ps2,
};

static dvcfg_hw_t lpt_hwsel_array[] = {
/* 0x0 */	&lpt_hw_IBM,
/* 0x1 */	&lpt_hw_TRADNEC,
/* 0x2 */	&lpt_hw_NEC,
/* 0x3 */	&lpt_hw_IBM
};

struct dvcfg_hwsel lpt_hwsel = {
	DVCFG_HWSEL_SZ(lpt_hwsel_array),
	lpt_hwsel_array
};
