/*	$NecBSD: autoscan.h,v 1.20.10.1.2.2 2000/07/17 03:16:07 honda Exp $	*/
/*	$NetBSD$	*/

/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 1996, 1997, 1998
 *	NetBSD/pc98 porting staff. All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _I386_AUTOSCAN_H_
#define _I386_AUTOSCAN_H_

#include <sys/queue.h>
#include <machine/diskutil.h>

struct dos_check_args {
	struct disklabel *lp;		/* IN: disklabel pointer */
	struct cpu_disklabel *cdp;	/* IN: cpu disklabel pointer */

	u_char *bufp;			/* IN: data buf */
	dev_t dev;			/* IN: device */
	void (*start) __P((struct buf *));	/* IN: strategy routine */

#define	GEO_CHG_EN	0x01
	u_int flag;			/* IN: control flags */
#define	DOS_CHECK_NO_HINT ((u_long) -1)
};

#define	IS_BSDFS(pt) \
	((pt)->se_fstype == FS_BSDFFS || (pt)->se_fstype == FS_BSDLFS)

struct disk_slice_hook {
	dev_t ds_dev;
	u_long ds_sector;

	LIST_ENTRY(disk_slice_hook) ds_chain;
};

/* scsi disk geo */
struct scsi_disk_geometry {
	u_int16_t sdg_tracks;
	u_int16_t sdg_sectors;
};

struct sdg_conv_element {
	struct scsi_disk_geometry sce_org;
	struct scsi_disk_geometry sce_mod;
};

struct sdg_conv_table {
	u_int sct_sz;
	struct sdg_conv_element *sct_pt;
};

/* macro */
#define	SDG_CONV_ELEMENT_SZ(array) (sizeof(array)/sizeof(struct sdg_conv_element))

#ifdef	_KERNEL
int read_cpudisklabel __P((struct dos_check_args *));
int setup_cpudisklabel __P((struct dos_check_args *));
int netbsd_start_slice __P((dev_t, struct cpu_disklabel *));

char *read_slice_disklabel __P((dev_t, void (*) __P((struct buf *)), struct disklabel *, struct cpu_disklabel *, u_long));
int find_bootdisk_slice __P((dev_t, void (*) __P((struct buf *)), struct disklabel *, struct cpu_disklabel *));

struct disk_slice_hook *disk_slice_hook_scan __P((dev_t));
struct disk_slice_hook *disk_slice_hook_insert __P((dev_t, u_long));
int disk_slice_hook_remove __P((struct disk_slice_hook *));

struct buf;
dev_t strategy_to_blkdev __P((dev_t, void (*) __P((struct buf *))));
dev_t findblkmajor __P((const char *));
#endif /* _KERNEL */
#endif /* !_I386_AUTOSCAN_H_ */
