/*	$NecBSD: vsc-action.c,v 1.1.2.1 2001/11/01 04:53:05 honda Exp $	*/
/*	$NetBSD$	*/

/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 1994, 1995, 1996, 1997, 1998
 *	NetBSD/pc98 porting staff. All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

struct proc;

#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/errno.h>
#include <sys/device.h>
#include <machine/vm86bios.h>

#include <machine/vscio.h>

#include <i386/isa/vsc/config.h>
#include <i386/isa/vsc/vsc.h>

static int revoke_terminal __P((char *));

static int
revoke_terminal(fname)
	char *fname;
{
	int i, fd;

	for (i = 0; i < 10; i ++)
		close(i);

	fd = open(fname, O_RDWR, 0777);
	if (fd < 0)
		exit(1);

	dup(fd);
	dup(fd);
	return fd;
}


int
main(argc, argv)
	int argc;
	char *argv[];
{
	int op, fd, ch;
	u_char *fname;
	char *action;
	int i;

	fname = "/dev/ttyv0";
	chdir("/");

	if (fork() == 0)
	{
		while (1)
		{
			fd = revoke_terminal(fname);
			if (ioctl(fd, VSC_KEY_ACTION, &op))
				exit(255);

			fd = revoke_terminal(fname);
			system("/bin/sh /etc/vsc-script");
			sleep(1);
		}
	}
	exit(0);
}
