/*	$NetBSD: getsecs.c,v 1.1.1.1 1997/03/14 02:40:32 perry Exp $	*/

/* extracted from netbsd:sys/arch/i386/netboot/misc.c */

#include <sys/types.h>

#include <lib/libsa/stand.h>

#include "libi386.h"

#ifdef	ORIGINAL_CODE
extern int biosgetrtc __P((u_long*));
static inline u_long bcd2dec __P(u_long));
#endif	/* !PC-98 */

static inline u_long
bcd2dec(arg)
u_long arg;
{
  return((arg >> 4) * 10 + (arg & 0x0f));
}

#ifndef	ORIGINAL_CODE
struct rtcbuf {
	u_int8_t year;
	u_int8_t month;
	u_int8_t day;
	u_int8_t hour;
	u_int8_t minute;
	u_int8_t second;
} __attribute__((packed));

extern struct rtcbuf rtcbuf;
extern int biosgetrtc __P((struct rtcbuf *));

time_t
getsecs()
{
	time_t sec;

	if(biosgetrtc(&rtcbuf) != 0)
	{
		panic("RTC invalid");
	}

	sec = bcd2dec((u_long) rtcbuf.hour);
	sec *= 60;
	sec += bcd2dec((u_long) rtcbuf.minute);
	sec *= 60;
	sec += bcd2dec((u_long) rtcbuf.second);

	return sec;
}

#else	/* !PC98 */

time_t
getsecs() {
  /*
   * Return the current time in seconds
   */

  u_long t;
  time_t sec;

  if(biosgetrtc(&t))
      panic("RTC invalid");

  sec = bcd2dec(t & 0xff);
  sec *= 60;
  t >>= 8;
  sec += bcd2dec(t & 0xff);
  sec *= 60;
  t >>= 8;
  sec += bcd2dec(t & 0xff);

  return(sec);
}
#endif	/* !PC98 */
