/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 2000
 *	NetBSD/pc98 porting staff. All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef	PCCS_ATTRWIN_BASEADDR
#define	PCCS_ATTRWIN_BASEADDR	0xc0000
#endif
#ifndef	PCCS_ATTRWIN_SIZE
#define	PCCS_ATTRWIN_SIZE	NBPG
#endif
#ifndef	PCCS_MAX_TARGET_SLOT
#define	PCCS_MAX_TARGET_SLOT	1
#endif
#ifndef	PCCS_CHIP_IOBASE
#define	PCCS_CHIP_IOBASE	0x3e0
#endif

#include "busio_user.h"
#include <i386/pccs/tuple.h>
#include <i386/pccs/pccsio.h>
#include <i386/pccs/pccsvar.h>
#include <i386/pccs/pccshw.h>

/* hardware interfaces */
int pccshw_init __P((u_long));
int pccshw_slot_init __P((slot_handle_t));
int pccshw_slot_shutdown __P((slot_handle_t));
int pccshw_iomem_map __P((slot_handle_t, int, struct slot_device_iomem *));

/* pccs interfaces */
int pccs_open __P((slot_handle_t, struct card_info *));
int pccs_card_open __P((slot_handle_t, struct card_info *));
int pccs_close __P((slot_handle_t, struct card_info *));
int pccs_delay __P((int));

/* virtual address relocation */
extern u_long ourseg;
extern u_int8_t *cisbufp;
#define	PCCS_PHYSTOV(paddr) ((paddr) - (ourseg << 4)) /* -BOOTSEG */

/* XXX */
int	 strncmp __P((const char *, const char *, size_t));
char	*strncpy __P((char *, const char *, size_t));
