/*	$NecBSD: start.S,v 1.2.10.4 2000/07/14 05:41:53 honda Exp $	*/
/*	$NetBSD$	*/
#ifndef	ORIGINAL_CODE
/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 1999, 2000
 *	NetBSD/pc98 porting staff. All rights reserved.
 */
#endif	/* PC-98 */
/*
 * Ported to boot 386BSD by Julian Elischer (julian@tfs.com) Sept 1992
 *
 * Mach Operating System
 * Copyright (c) 1992, 1991 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

/*
  Copyright 1988, 1989, 1990, 1991, 1992 
   by Intel Corporation, Santa Clara, California.

                All Rights Reserved

Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appears in all
copies and that both the copyright notice and this permission notice
appear in supporting documentation, and that the name of Intel
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.

INTEL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL INTEL BE LIABLE FOR ANY SPECIAL, INDIRECT, OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <machine/asm.h>
#define	addr32	.byte 0x67
#define	data32	.byte 0x66

SIGNATURE	=	0xaa55
RELOCSEG	=	0x9000
BOOTSEG		=	0x1100	# boot will be loaded here (below 640K)
BOOTSTACK	=	0xfffc	# boot stack
BOOTSIZE	=	0x1000
NUMPART		=	8

#define	ERROR_DISK_READ		0
#define	ERROR_DISK_WRITE	1
#define	ERROR_FATAL		9

#define	HELP_LINE		1
#define	DISK_LINE		4
#define	DOS_PARTITION_LINE	5
#define	ERROR_MSG_LINE		24

	.text	
	.globl	start

##########################################################
# First stage
##########################################################
ENTRY(boot1)
start:
	jmp 1f
_C_LABEL(start_cylinder):
	.word	0		/* saved boot cylinder */
	.ascii "IPL1   "
_C_LABEL(copyright):
	.asciz "Boot helper v1.0"
_C_LABEL(help):	
	.asciz "press [ws+123..]"

1:
	cli
	xorl	%eax,%eax
	mov     %ax,%ds
	movl	%eax,%ebp

	data32				/* setup es */
	movl	$RELOCSEG,%eax
	movl	%ax,%es

	movl	%ax,%ss			/* setup stack */
	data32
	movl	$BOOTSTACK, %esp

#if	0
	# crt setup
	addr32				# check has PEGC ?
	testb	$0x40,0x45c
	jz	1f

	movb	$0x30,%ah		# PC-9821 series ext graphic mode
	movb	$0x0c,%al
	movb	$0x32,%bh		# 31.5 khz, 30 lines, 640*480

	addr32				# if mate note with RAM disk
	testb   $0x80,0x400
	jnz     2f

	addr32				# if note keyboard
	testb   $0x8,0x481
	jnz     2f

	addr32 
	testb   $0x20,0x54c		# if mate 31k
	jnz	2f

1:
	movb	$0x42,%ah		# 400 dots
	movb	$0xc0,%ch
	int	$0x18

	data32				# 25 line
	movl	$0xa00,%eax
2:
	int	$0x18

	movb    $0x0c,%ah		# crt on
	int	$0x18
#endif

	# load second stage block
	movb	$0x06,%ah
	data32
	movl	$BOOTSIZE,%ebx		# blocksize minimum
	xorl	%ecx,%ecx
	xorl	%edx,%edx
	xorl	%ebp,%ebp

	addr32
	movb	0x584,%al
	andb    $0xf0,%al
	cmpb    $0x90,%al		# FD
	jz	3f
	cmpb    $0x30,%al		# 1.44 FD
	jz	3f
	jmp	4f
3:
	movb	$0xd6,%ah
	incb	%dl
	movb	$2,%ch
4:
	addr32
	movb	0x584,%al
	data32
	int	$0x1b
5:
	jc	5b

	data32
	ljmp	$RELOCSEG, $_C_LABEL(start2)

	. = _C_LABEL(boot1) + 0x1fe
	.short	SIGNATURE
	. = _C_LABEL(boot1) + 0x200
_C_LABEL(dos_partition_table):
	. = _C_LABEL(boot1) + 0x400

##########################################################
# Second stage
##########################################################
ENTRY(start2)
	jmp	1f
_C_LABEL(bootmenu_skip):
	.byte	0
_C_LABEL(boot_device):
	.byte	0

1:
	data32				/* setup ds */
	xorl	%eax,%eax
	mov     %ax,%ds
	movl	%eax,%ebp

	data32				/* setup es */
	movl	$BOOTSEG,%eax
	movl	%ax,%es

	movl	%ax,%ss			/* setup stack */
	data32
	movl	$BOOTSTACK, %esp

	data32
	xorl	%edi,%edi
	data32
	movl	$_C_LABEL(copyright),%esi
	data32
	call 	_C_LABEL(print_message)

	data32
	movl	$HELP_LINE*160,%edi
	data32
	movl	$_C_LABEL(help),%esi
	data32
	call 	_C_LABEL(print_message)

	# save boot device
	addr32
	movb	0x584, %al
	addr32
	movb	%al, %cs:_C_LABEL(boot_device)

	# check keypress (TAB)
	movb	$1,%ah
	data32
	int	$0x18
	cmpb	$0x09,%al
	jz	1f
	addr32
	movb	$1,%cs:_C_LABEL(bootmenu_skip)

	# check saved start parition
1:
	addr32
	movl	%cs:_C_LABEL(start_cylinder),%ebx
	orl	%ebx,%ebx
	jz	load_bootcode

	movl	%ebx,%eax
	xorb	%bh,%bh
	addr32
	movb	%ah,0x584

load_bootcode:
	# step I: loading the dospartition table
	pushl	%ebx
	movb	$0x06,%ah
	data32
	movl	$BOOTSIZE,%ebx		# blocksize minimum
	xorl	%ecx,%ecx
	xorl	%edx,%edx
	xorl	%ebp,%ebp

	addr32
	movb	0x584,%al
	andb    $0xf0,%al
	cmpb    $0x90,%al		# FD
	jz	3f
	cmpb    $0x30,%al		# 1.44 FD
	jz	3f
	jmp	4f
3:
	movb	$0xd6,%ah
	incb	%dl
	movb	$2,%ch
4:
	addr32
	movb	0x584,%al
	data32
	int	$0x1b
	jnc	5f
	movb	$ERROR_DISK_READ, %al
	data32
	call	_C_LABEL(disk_error)
5:
	popl	%ebx

	addr32
	cmpb	$1,%cs:_C_LABEL(bootmenu_skip)
	jz	find_netbsd_partition

	data32
	call _C_LABEL(print_disk)
	data32
	call _C_LABEL(pirnt_label_all)
	data32
	call _C_LABEL(get_inst)
	orb %al,%al
	jnz load_bootcode

	# step II: search our NetBSD entry
find_netbsd_partition:
	data32
	movl	$_C_LABEL(dos_partition_table),%ebp
	movb	$1,%cl
	jmp 	9f

1:
	data32
	addl	$32,%ebp
	incb	%cl
	cmpb	$(NUMPART+1),%cl	# ndospart
	jz	2f

9:
	orl	%ebx,%ebx
	jz	3f
	cmpb	%cl,%bl
	jz	slice_found
	jmp	1b

3:
	addr32
	movb	%es:0(%ebp),%al
	andb	$0x7f,%al
	cmpb	$0x14,%al		# check mid
	jnz	1b
	addr32
	cmpb	$0xc4,%es:1(%ebp)	# check sid with active
	jnz	1b
	jmp	slice_found

2:	orl	%ebx,%ebx
	jz	slice_not_found
	xorl	%ebx,%ebx
	jmp	find_netbsd_partition

slice_not_found:	# terminate
	movb	$ERROR_FATAL, %al
	data32
	call	_C_LABEL(disk_error)
	jmp	slice_not_found

	# step III: load our boot code
slice_found: 	
	addr32
	movb	%es:8(%ebp),%dl		# sector
	addr32
	movb	%es:9(%ebp),%dh		# head
	addr32
	movl	%es:10(%ebp),%ecx	# cyl

	orl	%ecx,%ecx
	jz	slice_not_found

	pushl	%ecx
	movb	$0x06,%ah
	data32
	movl	$512*16,%ebx
	xorl	%ebp,%ebp

	addr32
	movb	0x584,%al
	andb    $0xf0,%al
	cmpb    $0x90,%al		# FD
	jz	3f
	cmpb    $0x30,%al		# 1.44 FD
	jz	3f
	jmp	4f
3:
	movb	$0xd6,%ah
	incb	%dl
	movb	$2,%ch
4:
	addr32
	movb	0x584,%al
	pushl	%eax
	int	$0x1b
	popl	%eax
	popl	%ecx

	xorb	%ah,%ah
	xorl	%edi,%edi
	data32
	ljmp	$BOOTSEG, $0

###########################################################
# print
###########################################################
ENTRY(print_message)
	data32
	pusha
	pushl	%ds
	pushl	%es

	movl	%cs, %ax
	movl	%ax, %ds
	movb	$0xe1, %ah
	jmp	print_entry_sub


ENTRY(print_entry)
	data32
	pusha
	pushl	%ds
	pushl	%es
	
	movl	%es, %dx
	movl	%dx, %ds

print_entry_sub:
	data32
	movl	$0xa000, %edx
	movl	%dx, %es
	movb	$16, %cl

nextb:
	cld
	lodsb	
	addr32
	movb	%al, %es:(%edi)
	addr32
	movb	%ah, %es:0x2000(%edi)
	incl	%edi
	incl	%edi
	decb	%cl
	jnz	nextb

done:
	popl	%es
	popl	%ds
	data32
	popa
	data32
	ret

###########################################################
# print label
###########################################################
ENTRY(pirnt_label_all)
	data32
	pusha

	data32
	movl	$_C_LABEL(dos_partition_table),%ebp
	data32	
	movl	$DOS_PARTITION_LINE*160 + 4,%edi
	movb	$1,%cl

2:
	movb	$0xe1, %ah
	cmpb	%cl, %bl
	jnz	3f
	movb	$0x81, %ah

3:
	movl	%ebp,%esi
	data32
	addl	$16,%esi
	data32
	call	_C_LABEL(print_entry)

	data32
	addl	$80*2, %edi
	data32
	addl	$32,%ebp
	incb	%cl
	cmpb	$(NUMPART+1),%cl
	jnz	2b

	data32	
	popa
	data32
	ret

###########################################################
# get key
###########################################################
ENTRY(get_inst)
	movb	$0x0, %ah
	data32
	int	$0x18

	addr32
	movb	0x584, %ah

0:
	cmpb	$0x77,%al	#wd 'w'
	jnz	1f
	movb	$0x80,%ah
	xorb	%bl,%bl
	jmp	9f

1:
	cmpb	$0x73,%al	#scsi 's'
	jnz	hellow_world
	movb	$0xa0,%ah
	xorb	%bl,%bl
	jmp	9f

hellow_world:
	cmpb	$0x67,%al	# go! 'g'
	jnz	disk_change
	xorb	%al,%al
	jmp	9f

disk_change:
	cmpb	$0x2b,%al	# '+'
	jnz	boot_part_save
	incb	%ah
	xorb	%bl,%bl
	jmp	9f

boot_part_save:
	cmpb	$0x50,%al	# 'P' save
	jnz	part_change
	data32
	call	_C_LABEL(save_boot_data)
	jmp	9f

part_change:
	cmpb	$0x30,%al	# 1 - 9 partitions
	jl	_C_LABEL(get_inst)
	cmpb	$0x3a,%al
	jg	_C_LABEL(get_inst)
	movb	%al,%bl
	subb	$0x30,%bl

9:
	addr32
	movb	%ah,0x584
	data32
	ret

###########################################################
# print disk name
###########################################################
_C_LABEL(disk_name_wd):
	.asciz	"target disk: wd0"
_C_LABEL(disk_name_sd):
	.asciz	"target disk: sd0"
_C_LABEL(disk_name_fd):
	.asciz	"target disk: fd0"

ENTRY(print_disk)
	addr32
	movb	0x584, %al
	data32
	movl	$DISK_LINE * 160, %edi

	andb	$0xf0,%al
	cmpb	$0xa0, %al
	jnz	1f

0:
	data32
	movl    $_C_LABEL(disk_name_sd), %esi
	jmp	9f

1:
	cmpb	$0x80, %al
	jnz	2f
	data32
	movl	$_C_LABEL(disk_name_wd), %esi
	jmp	9f

2:
	data32
	movl	$_C_LABEL(disk_name_fd), %esi

9:
	addr32
	movb	0x584, %al
	andb	$0xf,%al
	addb	$0x30,%al
	addr32
	movb	%al,%cs:15(%esi)
	data32
	call 	_C_LABEL(print_message)
	data32
	ret	

###########################################################
# disk read error
###########################################################
_C_LABEL(disk_read_error_msg):
	.asciz "disk read error "
_C_LABEL(disk_write_error_msg):
	.asciz "disk write error"
_C_LABEL(disk_fatal_error_msg):
	.asciz "fatal error!!!  "
	
ENTRY(disk_error)
	data32
	pusha

	data32
	movl	$ERROR_MSG_LINE * 160, %edi

0:
	cmpb	$ERROR_DISK_READ, %al
	jnz	1f
	data32
	movl	$_C_LABEL(disk_read_error_msg), %esi
	jmp	8f

1:
	cmpb	$ERROR_DISK_WRITE, %al
	jnz	2f
	data32
	movl	$_C_LABEL(disk_write_error_msg), %esi
	jmp	8f

2:
	cmpb	$ERROR_FATAL, %al
	jnz	9f
	data32
	movl	$_C_LABEL(disk_fatal_error_msg), %esi
	jmp	8f

8:
	data32
	call 	_C_LABEL(print_message)
	
9: 	
	data32
	popa
	data32
	ret

###########################################################
# save boot partition
###########################################################
ENTRY(save_boot_data)
	data32
	pusha
	push	%es
	pushl	%ebx

	mov	%cs,%eax
	mov	%eax,%es

	movb	$0x06,%ah
	data32
	movl	$512,%ebx		# blocksize minimum
	xorl	%ecx,%ecx
	xorl	%edx,%edx
	data32
	movl	$_C_LABEL(disk_work_area), %ebp

	addr32
	movb	%cs:_C_LABEL(boot_device),%al
	andb    $0xf0,%al
	cmpb    $0x90,%al		# FD
	jz	3f
	cmpb    $0x30,%al		# 1.44 FD
	jz	3f
	jmp	4f
3:
	movb	$0xd6,%ah
	incb	%dl
	movb	$2,%ch
4:
	addr32
	movb	%cs:_C_LABEL(boot_device),%al
	data32
	int	$0x1b
	popl	%ebx
	jnc	5f
	movb	$ERROR_DISK_READ, %al
	data32
	call	_C_LABEL(disk_error)
	jmp	save_boot_data_exit

5:
	addr32
	movb	0x584,%bh
	data32
	movl	$_C_LABEL(disk_work_area), %esi
	addr32
	movl	%ebx, %cs:_C_LABEL(start_cylinder)(%esi)

	movb	$0x05,%ah
	data32
	movl	$512,%ebx		# blocksize minimum
	xorl	%ecx,%ecx
	xorl	%edx,%edx
	data32
	movl	$_C_LABEL(disk_work_area), %ebp

	addr32
	movb	%cs:_C_LABEL(boot_device),%al
	andb    $0xf0,%al
	cmpb    $0x90,%al		# FD
	jz	3f
	cmpb    $0x30,%al		# 1.44 FD
	jz	3f
	jmp	4f
3:
	movb	$0xd5,%ah
	incb	%dl
	movb	$2,%ch
4:
	addr32
	movb	%cs:_C_LABEL(boot_device),%al
	data32
	int	$0x1b
	jnc	save_boot_data_exit
	movb	$ERROR_DISK_WRITE, %al
	data32
	call	_C_LABEL(disk_error)

save_boot_data_exit:
	pop	%es
	data32
	popa
	data32
	ret

ENTRY(disk_work_area)
	.long	0
